// Code generated by go-swagger; DO NOT EDIT.

package data_sources

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewPostDataSourcesParams creates a new PostDataSourcesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostDataSourcesParams() *PostDataSourcesParams {
	return &PostDataSourcesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostDataSourcesParamsWithTimeout creates a new PostDataSourcesParams object
// with the ability to set a timeout on a request.
func NewPostDataSourcesParamsWithTimeout(timeout time.Duration) *PostDataSourcesParams {
	return &PostDataSourcesParams{
		timeout: timeout,
	}
}

// NewPostDataSourcesParamsWithContext creates a new PostDataSourcesParams object
// with the ability to set a context for a request.
func NewPostDataSourcesParamsWithContext(ctx context.Context) *PostDataSourcesParams {
	return &PostDataSourcesParams{
		Context: ctx,
	}
}

// NewPostDataSourcesParamsWithHTTPClient creates a new PostDataSourcesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostDataSourcesParamsWithHTTPClient(client *http.Client) *PostDataSourcesParams {
	return &PostDataSourcesParams{
		HTTPClient: client,
	}
}

/* PostDataSourcesParams contains all the parameters to send to the API endpoint
   for the post data sources operation.

   Typically these are written to a http.Request.
*/
type PostDataSourcesParams struct {

	// Body.
	Body PostDataSourcesBody

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post data sources params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostDataSourcesParams) WithDefaults() *PostDataSourcesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post data sources params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostDataSourcesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post data sources params
func (o *PostDataSourcesParams) WithTimeout(timeout time.Duration) *PostDataSourcesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post data sources params
func (o *PostDataSourcesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post data sources params
func (o *PostDataSourcesParams) WithContext(ctx context.Context) *PostDataSourcesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post data sources params
func (o *PostDataSourcesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post data sources params
func (o *PostDataSourcesParams) WithHTTPClient(client *http.Client) *PostDataSourcesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post data sources params
func (o *PostDataSourcesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the post data sources params
func (o *PostDataSourcesParams) WithBody(body PostDataSourcesBody) *PostDataSourcesParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the post data sources params
func (o *PostDataSourcesParams) SetBody(body PostDataSourcesBody) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *PostDataSourcesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
