// Code generated by go-swagger; DO NOT EDIT.

package data_sources

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/recolabs/redash-go-sdk/gen/models"
)

// PostDataSourcesReader is a Reader for the PostDataSources structure.
type PostDataSourcesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostDataSourcesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostDataSourcesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewPostDataSourcesDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPostDataSourcesOK creates a PostDataSourcesOK with default headers values
func NewPostDataSourcesOK() *PostDataSourcesOK {
	return &PostDataSourcesOK{}
}

/* PostDataSourcesOK describes a response with status code 200, with default header values.

OK
*/
type PostDataSourcesOK struct {
	Payload *models.DataSource
}

func (o *PostDataSourcesOK) Error() string {
	return fmt.Sprintf("[POST /data_sources][%d] postDataSourcesOK  %+v", 200, o.Payload)
}
func (o *PostDataSourcesOK) GetPayload() *models.DataSource {
	return o.Payload
}

func (o *PostDataSourcesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DataSource)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostDataSourcesDefault creates a PostDataSourcesDefault with default headers values
func NewPostDataSourcesDefault(code int) *PostDataSourcesDefault {
	return &PostDataSourcesDefault{
		_statusCode: code,
	}
}

/* PostDataSourcesDefault describes a response with status code -1, with default header values.

error
*/
type PostDataSourcesDefault struct {
	_statusCode int

	Payload *models.Error
}

// Code gets the status code for the post data sources default response
func (o *PostDataSourcesDefault) Code() int {
	return o._statusCode
}

func (o *PostDataSourcesDefault) Error() string {
	return fmt.Sprintf("[POST /data_sources][%d] PostDataSources default  %+v", o._statusCode, o.Payload)
}
func (o *PostDataSourcesDefault) GetPayload() *models.Error {
	return o.Payload
}

func (o *PostDataSourcesDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*PostDataSourcesBody post data sources body
swagger:model PostDataSourcesBody
*/
type PostDataSourcesBody struct {

	// name
	Name string `json:"name,omitempty"`

	// options
	Options interface{} `json:"options,omitempty"`

	// type
	Type string `json:"type,omitempty"`
}

// Validate validates this post data sources body
func (o *PostDataSourcesBody) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this post data sources body based on context it is used
func (o *PostDataSourcesBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *PostDataSourcesBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *PostDataSourcesBody) UnmarshalBinary(b []byte) error {
	var res PostDataSourcesBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
